// import {FormSchema} from '@/components/Table';
import {treeOptionsListApi} from "@/api/demo/tree";
import {areaRecord} from "@/api/demo/cascader";
import dayjs from "dayjs";
import {optionsListApi} from "@/api/demo/select";
import {Input, FormItem, FormItemRest, Select} from "ant-design-vue";
import { ApiSelect, FormSchema } from '@/components/Form';

import companyType from './drawer-form/companyType';
import annualPurchaseAmount from './drawer-form/annualPurchaseAmount';
import timeZone from './drawer-form/timeZone';
import {uploadApi} from "@/api/sys/upload";

const custom_typeKey2typeValueRules = (model) => {
  return [
    {
      // required: true,
      // trigger: 'blur',
      validator: async () => {
        Logger.log('custom_typeKey2typeValueRules', model);
        if (!model.telephoneAreaCode) return Promise.reject('请选择电话区号');
        if (!model.telephoneNumber) return Promise.reject('请输入电话号码');
        Promise.resolve();
      },
    },
  ];
};

const add = (model) => {
  console.log('add-',model);
  Logger.log('add=', model);
};

export const schemas: FormSchema[] = [
  {
    field: 'contactName',
    component: 'Input',
    label: '联系人名称',
    colProps: {
      span: 24,
    },
    rules: [{required: true, trigger: 'blur'}],
  },
  {
    field: 'email',
    component: 'Input',
    label: '邮箱',
    colProps: {
      span: 24,
    },
  },
  {
    field: 'socialPlatform',
    fields: ['socialAccount','socialCount'],
    component: 'Input',
    // label: 'renderColContent渲染',
    /**!!!renderColContent 没有FormItem 包裹, 若想要 Form 提交需要带上数据须 <FormItem name={}></FormItem> 包裹： 示例如下*/
    renderColContent({model, field}, {disabled}) {
      return (
        <FormItem
          name="social"
          label="社交平台"
          // rules={[{ trigger: 'blur',required: true, }]}
          // rules={custom_typeKey2typeValueRules(model)}
        >
          <Input.Group compact>
            {/*<Select*/}
            {/*  allowClear*/}
            {/*  disabled={disabled}*/}
            {/*  style="width: 120px"*/}
            {/*  v-model:value={model[field]}*/}
            {/*>*/}
            {/*  <Select.Option value="公司名称">公司名称</Select.Option>*/}
            {/*  <Select.Option value="产品名称">产品名称</Select.Option>*/}
            {/*</Select>*/}
            <ApiSelect
              style="width: 120px"
              v-model:api={optionsListApi}
              placeholder="社交平台"
              showSearch
              v-model:value={model['socialPlatform']}
              optionFilterProp="label"
              resultField="list"
              labelField="name"
              valueField="id"
            />
            <FormItemRest>
              <Input
                style="width: calc(100% - 120px); margin-left: -1px;"
                placeholder="社交账号"
                v-model:value={model['socialAccount']}
                disabled={disabled}
                // rules={[{ type: 'number',trigger: 'blur',required: true, }]}
                // rules={custom_typeKey2typeValueRules(model)}
              />
            </FormItemRest>
            {/*<div>*/}
            {/*  <a-button shape="circle" onClick={add(model)}>+</a-button>*/}
            {/*  /!*<a-button shape="circle" v-if={Number(model['socialCount']) > 0}>-</a-button>*!/*/}
            {/*  /!*<a-button shape="circle" v-if={Number(model['socialCount']) === 0} onClick={add}>+</a-button>*!/*/}
            {/*  /!*<a-button shape="circle" v-if={Number(model['socialCount']) > 0} onClick={() => del(field)}>-</a-button>*!/*/}
            {/*</div>*/}
          </Input.Group>

        </FormItem>
      );
    },
    colProps: {
      span: 18,
    },
    dynamicDisabled: ({values}) => {
      return !!values.field_disabled;
    },
  },
  {
    field: '0',
    label: ' ',
    component: 'Input',
    render({model, field}, {disabled}) {
      return (
        <div>
          <a-button shape="circle" onClick={add(model)}>+</a-button>
          {/*<a-button shape="circle" v-if={Number(model['socialCount']) > 0}>-</a-button>*/}
          {/*<a-button shape="circle" v-if={Number(model['socialCount']) === 0} onClick={add}>+</a-button>*/}
          {/*<a-button shape="circle" v-if={Number(model['socialCount']) > 0} onClick={() => del(field)}>-</a-button>*/}
        </div>
      );
    },
    colProps: {
      span: 6,
    },
  },
  {
    field: 'telephoneAreaCode',
    fields: ['telephoneNumber'],
    component: 'Input',
    // label: 'renderColContent渲染',
    /**!!!renderColContent 没有FormItem 包裹, 若想要 Form 提交需要带上数据须 <FormItem name={}></FormItem> 包裹： 示例如下*/
    renderColContent({model, field}, {disabled}) {
      return (
        <FormItem
          name="telephone"
          label="联系电话"
          // rules={[{ trigger: 'blur',required: true, }]}
          // rules={custom_typeKey2typeValueRules(model)}
        >
          <Input.Group compact>

            <ApiSelect
              style="width: 120px"
              v-model:api={optionsListApi}
              placeholder="电话区号"
              showSearch
              v-model:value={model['telephoneAreaCode']}
              optionFilterProp="label"
              resultField="list"
              labelField="name"
              valueField="id"
              // rules={[{ trigger: 'blur',required: true, }]}
            />
            <FormItemRest>
              <Input
                style="width: calc(100% - 120px); margin-left: -1px;"
                placeholder="电话号码"
                v-model:value={model['telephoneNumber']}
                disabled={disabled}
                // rules={[{ trigger: 'blur',required: true, }]}
                // rules={custom_typeKey2typeValueRules(model)}
              />
            </FormItemRest>
          </Input.Group>
        </FormItem>
      );
    },
    colProps: {
      span: 16,
    },
    dynamicDisabled: ({values}) => {
      return !!values.field_disabled;
    },
  },
  // {
  //   field: 'typeKey2',
  //   fields: ['typeValue2'],
  //   component: 'Input',
  //   label: '复合',
  //   /**!!!renderColContent 没有FormItem 包裹, 若想要 Form 提交需要带上数据须 <FormItem name={}></FormItem> 包裹： 示例如下*/
  //   render({ model, field }, { disabled }) {
  //     return (
  //       <Input.Group>
  //         <Select
  //           disabled={disabled}
  //           style="width: 120px"
  //           allowClear
  //           v-model:value={model[field]}
  //         >
  //           <Select.Option value="测试类型">测试类型</Select.Option>
  //           <Select.Option value="测试名称">测试名称</Select.Option>
  //         </Select>
  //         <FormItem name="typeValue2"  rules={[{ required: true }]}>
  //           <FormItemRest>
  //             <Input
  //               placeholder="请输入"
  //               v-model:value={model['typeValue2']}
  //               disabled={disabled}
  //             />
  //           </FormItemRest>
  //         </FormItem>
  //       </Input.Group>
  //     );
  //   },
  //   colProps: {
  //     span: 12,
  //   },
  //   dynamicDisabled: ({values}) => {
  //     return !!values.field_disabled;
  //   },
  // },
  {
    field: 'position',
    component: 'Input',
    label: '职位',
    colProps: {
      span: 16,
    },
  },
  {
    field: 'remark',
    component: 'InputTextArea',
    label: '备注',
    colProps: {
      span: 24,
    },
  },
  {
    field: 'gender',
    component: 'RadioGroup',
    defaultValue: '0',
    label: '性别',
    componentProps: {
      options: [
        {label: '不设置', value: '0'},
        {label: '男', value: '1'},
        {label: '女', value: '1'},
      ],
    },
    colProps: {
      span: 24,
    },
  },
  {
    field: 'image',
    component: 'ImageUpload',
    label: '图片',
    subLabel: '(单张图片最大3M，最多上传5张图片)',
    // required: true,
    defaultValue: [
      'https://zos.alipayobjects.com/rmsportal/jkjgkEfvpUPVyRjUImniVslZfWPnJuuZ.png',
    ],
    componentProps: {
      api: uploadApi,
      accept: ['png', 'jpeg', 'jpg'],
      helpText: '单张图片最大3M，最多上传5张图片',
      maxSize: 3, //单个文件最大体积，单位 M
      maxNumber: 5,
    },
    // rules: [
    //   {
    //     required: true,
    //     trigger: 'change',
    //     validator(_, value) {
    //       if (isArray(value) && value.length > 0) {
    //         return Promise.resolve();
    //       } else {
    //         return Promise.reject('请选择上传图片');
    //       }
    //     },
    //   },
    // ],
  },
  {
    field: 'birthday',
    label: '生日',
    component: 'DatePicker',
    componentProps: {
      style: 'width: 100%;',
      format: 'YYYY-MM-DD',
    },
    colProps: {span: 16},
  },
  {
    component: 'Select',
    label: '职级',
    field: 'rank',
    colProps: {span: 24},
    componentProps: {
      options: [
        {
          label: '普通职员',
          value: '1',
        },
        {
          label: '中层管理者',
          value: '2',
        },
        {
          label: '高层管理者',
          value: '3',
        },
      ],
    },
  },
  // {
  //   field: 'remindTime2',
  //   component: 'DatePicker',
  //   label: '',
  //   colProps: {
  //     span: 6,
  //     offset: 2,
  //   },
  //   componentProps: {
  //     // disabledDate:(currentDate)=>{
  //     //   // Logger.log('currentDate',currentDate)
  //     //   // 禁用今天之前的天数
  //     //   return currentDate && currentDate < dayjs().subtract(1, 'day');
  //     // }
  //   },
  //   dynamicRules: ({values}) => {
  //     return [
  //       {
  //         // required: true,
  //         validator: (_, value) => {
  //           if (values.remindTime === '6') {
  //             if (!value) {
  //               return Promise.reject('不能为空');
  //             }
  //           }
  //
  //           return Promise.resolve();
  //         },
  //       },
  //     ];
  //   },
  //   show: ({values}) => {
  //     // Logger.log('vvv',values)
  //     return values.remindTime === '6';
  //   },
  // },
];
